#include <windows.h>
#include <stdio.h>

#include <mmreg.h>
#include <msacm.h>

HMMIO wav_handle;
unsigned long data_chunk_size, data_chunk_read;

MMCKINFO ChunkInfo;
MMCKINFO FormatChunkInfo;
DWORD		Res;


/*
FILE           *file;

char *pSrcBuf;
char *pDstBuf;

DWORD		cbRemaining;
DWORD		cbConverted;
DWORD		cbSrcBuf; // .. or whatever size you want
DWORD		cbDstBuf;

WAVEFORMATEX			wfxDst;
MPEGLAYER3WAVEFORMAT	MP3wfxSrc;

MMRESULT				res;
ACMSTREAMHEADER			ash;
HACMSTREAM				hCodec;

DWORD  dwBytesRead;
DWORD dwTotalBytesToRead;
DWORD dwTotalBytesWritten;
*/

__declspec(dllexport)  int init_wav_decode(char *in_filename, int dest_buffer_size, int nChannels, int nSamplesPerSec, int nAvgBitsPerSec)
{

DWORD return_value;

	wav_handle = mmioOpen(in_filename, 0, MMIO_READ);
	if (!wav_handle) 
		{
		printf("error opening file\n");
		//MessageBox(0, "Error opening file.", "Error Message", 0);  
		}
	else
		{
		// Find the RIFF chunk.
		memset(&ChunkInfo, 0, sizeof(MMCKINFO));
		Res = mmioDescend(wav_handle, &ChunkInfo, 0, MMIO_FINDRIFF);   
		if (Res != 0)
			{
			// can't find the riff chunk
			printf("can't find riff\n");
			}
		else
			{
			// Descend into the data chunk.
//			FormatChunkInfo.ckid = mmioStringToFOURCC("fmt", 0);  
			memset(&FormatChunkInfo, 0, sizeof(MMCKINFO));
			FormatChunkInfo.ckid = mmioStringToFOURCC("data", 0);  
			Res = mmioDescend(wav_handle, &FormatChunkInfo, &ChunkInfo, MMIO_FINDCHUNK);   
			if (Res != 0)
				{
				// can't find the data chunk
				}
            else
				{
				return_value = TRUE;
				}
			}
		}  // end if open ok

	data_chunk_size = ChunkInfo.cksize;
	data_chunk_read = 0;


return(TRUE);
}


__declspec(dllexport)  int close_wav_decode(void)
{
	mmioClose(wav_handle, 0);
return(TRUE);
}


__declspec(dllexport)  int do_wav_decode( char *out_buffer, DWORD bytes_to_decode)
{

DWORD return_value;

	// don't try and read past the end of the data chunk in the wave file
	if ((int)(data_chunk_size - data_chunk_read) > bytes_to_decode)
		Res = mmioRead(wav_handle, out_buffer, bytes_to_decode);
	else
		Res = mmioRead(wav_handle, out_buffer, data_chunk_size - data_chunk_read);
	
	data_chunk_read += Res;

	// 0 is eof, -1 is error
	if ((Res == -1) || (Res == 0))
		{
		return_value = 0;
		//is_eof = TRUE;
		}
	else
		return_value = Res;


return(return_value);


}

__declspec(dllexport)  int ReadWAVSampleRate(char *track_name,int *nChannels, int *nSamplesPerSec, int *nAvgBitsPerSec)
{
HMMIO handle;
MMCKINFO ChunkInfo;
MMCKINFO FormatChunkInfo;
WAVEFORMATEX WaveFormat;
DWORD return_value;

		// Zero out the ChunkInfo structure.
		memset(&ChunkInfo, 0, sizeof(MMCKINFO));
		//	Open the file.
		return_value = FALSE;
		handle = mmioOpen(track_name, 0, MMIO_READ);
		if (!handle) 
			{
			//MessageBox(0, "Error opening file.", "Error Message", 0);  
			//return;
			}
		else
			{
			// Find the RIFF chunk.
			Res = mmioDescend(handle, &ChunkInfo, 0, MMIO_FINDRIFF);   
			if (Res != 0)
				{
				// can't find the riff chunk
				}
			else
				{
				// Descend into the format chunk.
				FormatChunkInfo.ckid = mmioStringToFOURCC("fmt", 0);  
				Res = mmioDescend(handle, &FormatChunkInfo, &ChunkInfo, MMIO_FINDCHUNK);   
				if (Res != 0)
					{
					// can't find the format chunk
					}
                else
					{
					// Read the format chunk
					memset(&WaveFormat, 0, sizeof(WAVEFORMATEX));
					// mmioRead and mmioWrite return the number of bytes read or
					// written so don't call the CheckMMIOError fucntion for those.   
					Res = mmioRead(handle, (char*)&WaveFormat, FormatChunkInfo.cksize);

					if (Res > 0)
						{
//						set_outframe (WaveFormat.nSamplesPerSec, WaveFormat.nChannels);
//						printf("channels %d, samp-per-sec %d, bit-per-samp %d\n",
//						WaveFormat.nChannels,
//						WaveFormat.nSamplesPerSec,
//						WaveFormat.wBitsPerSample);
						*nChannels = WaveFormat.nChannels;
						*nSamplesPerSec = WaveFormat.nSamplesPerSec;
						*nAvgBitsPerSec = WaveFormat.wBitsPerSample * WaveFormat.nSamplesPerSec;
						return_value = TRUE;
						} // end if more than 0 bytes returned by mmioread
					} // end if found format chunk
				} // end if found riff chunk
			} // end if mmio open ok
		// Close the file
		mmioClose(handle, 0);

return(return_value);
}

/*
int main (int argc, char **argv)
{
DWORD retval;
char out_buffer[10000*2];
FILE*		fp;
DWORD decoded;

retval = init_wav_decode("d:\\test2.mp3", 10000, 2, 48000, 4800*4*8);

int init_wav_decode(char *in_filename, int dest_buffer_size, int nChannels, int nSamplesPerSec, int nAvgBitsPerSec)


if (NULL == (fp = fopen("d:\\test2.pcm", "w+b" ))) 
	{
	//
	}

retval = 10000;
decoded = 0;
while (retval == 10000)
	{
	retval = do_wav_decode(out_buffer, 10000);
	fwrite(out_buffer, 1, retval, fp);
	printf("decoded %d\n", decoded+=retval);
	}


fclose(fp);
retval = close_mp3_decode();

return(0);

}

*/








